package jtable;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.SwingUtilities;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;

public class JTableSortDemo {

    private static void constructGUI() {
    
        // Table content with 2 columns and 4 rows
        Object[][] data = {
                {"United States"    ,  297200005},
                {"China"            , 1306313812},
                {"Brazil"           ,  186112794},
                {"India"            , 1080264388}
        };
        String columnNames[] = {"Country", "Population"};
        TableModel model = new DefaultTableModel(data, columnNames) {
            public Class<?> getColumnClass(int column) {
                return getValueAt(0, column).getClass();
            }
        };
        JTable table = new JTable(model);

        // Appry RowSorter to JTable
        TableRowSorter<TableModel> sorter = 
                new TableRowSorter<TableModel>(model);
        table.setRowSorter(sorter);

        JScrollPane scrollPane = new JScrollPane(table);
        JFrame frame = new JFrame("Sorting Table");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.add(scrollPane);
        frame.setSize(300, 200);
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                constructGUI();
            }
        });
    }
}
